
#define T_CS 	2
#define T_IRQ 	3

#define X_CONST 240
#define Y_CONST 320

#define PREC_TOUCH_CONST 10

#define PixSizeX	-14.58
#define PixOffsX	3800

#define PixSizeY	-10.625
#define PixOffsY	3800

/**********************************************
Val Zone
**********************************************/
int TP_X,TP_Y;
int last_i,last_j;
int now_i,now_j;
unsigned long last_time;
unsigned int counter;




#include <Adafruit_GFX.h>    // Core graphics library
#include "Adafruit_ILI9340.h" // Hardware-specific library
#include <SPI.h>




// TFT display and SD card will share the hardware SPI interface.
// Hardware SPI pins are specific to the Arduino board type and
// cannot be remapped to alternate pins.  For Arduino Uno,
// Duemilanove, etc., pin 11 = MOSI, pin 12 = MISO, pin 13 = SCK.
#define TFT_RST 8
#define TFT_DC 9
#define TFT_CS 10
//#define SD_CS 4

Adafruit_ILI9340 tft = Adafruit_ILI9340(TFT_CS, TFT_DC, TFT_RST);

void setup(void) {
  pinMode(T_CS,   OUTPUT);
  digitalWrite(T_CS,  HIGH);

  //Serial.println("OK!");
  tft.begin();

  
  tft.fillScreen(ILI9340_BLACK);
  //Serial.begin(115200);
  Touch_Init();  

}

void loop() {
    unsigned int  i,j;
    //Touch_Init();
   	while(Touch_DataAvailable() == 1)
	{

		Touch_Read();
		i = Touch_GetX();
		j = Touch_GetY();
		if(i>239) i = 239;
		if(j>319) j = 319;
                
		
                tft.drawLine(i, j, i, j, ILI9340_WHITE);
                //Serial.print(TP_X);
                //Serial.print("    ");
                //Serial.println(TP_Y);

	}  
  
}

void Touch_Init(void)
{

    pinMode(T_CS,   OUTPUT);
    //SPI.begin();
     //SPI.setDataMode(SPI_MODE0);
  //SPI.setBitOrder(MSBFIRST);
  SPI.setClockDivider(SPI_CLOCK_DIV8);
    pinMode(T_IRQ,  INPUT);

	digitalWrite(T_CS,  HIGH);


}

void Touch_WriteData(unsigned char data)
{

  SPI.transfer(data);

  
}

unsigned int Touch_ReadData()
{
	unsigned char nop;
	unsigned int data = 0;
	unsigned int mdata;
	unsigned int ldata;
        mdata = SPI.transfer(0);
        ldata = SPI.transfer(0);
        data = (ldata>>3)|(mdata<<5);
	return(data);
}
void Touch_Read()
{
	unsigned long tx=0;
	unsigned long ty=0;

	digitalWrite(T_CS,LOW);                    

	for (int i=0; i<PREC_TOUCH_CONST; i++)
	{
		Touch_WriteData(0x90);        
                 //delayMicroseconds(1);
               
		ty+=Touch_ReadData();

		Touch_WriteData(0xD0);      
                //delayMicroseconds(1);
                
		tx+=Touch_ReadData();
          }

	digitalWrite(T_CS,HIGH);

	TP_X=tx/PREC_TOUCH_CONST;
	TP_Y=ty/PREC_TOUCH_CONST;
}

char Touch_DataAvailable()
{
  char avail;
  avail = !digitalRead(T_IRQ);
  return avail;
}

int Touch_GetX()
{
	int value;
	value = ((TP_X-PixOffsX)/PixSizeX);
	if (value < 0)
		value = 0;
	return value;
}
int Touch_GetY()
{
	int value;
	value = ((TP_Y-PixOffsY)/PixSizeY);
	if (value < 0)
		value = 0;
	return value;
}
